Foreman - Bug #6725

The "LOCALBOOT 0" entry causes some bare metal machines to stuck during boot
07/22/2014 12:22 PM - Dominic Cleal

Status: New
Priority: Normal
Assignee:

Category: Templates

Target version:

Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1122153 Red Hat JIRA:

Pull request:

Description

Cloned from https://bugzilla.redhat.com/show_bug.cqi?id=1122153
++ This bug was initially created as a clone of Bug #1122152 ++

Foreman: The "LOCALBOQT 0" entry causes some bare metal machines to stuck during boot.

Environment:

rhel-osp-installer-0.1.1-1.el6ost.noarch
foreman-proxy-1.6.0.8-1.el6sat.noarch
foreman-installer-1.5.0-0.4.RC2.el6ost.noarch
ruby193-rubygem-foreman-tasks-0.6.4-2.el6sat.noarch
rubygem-foreman_api-0.1.11-4.el6sat.noarch
openstack-foreman-installer-2.0.15-1.el6ost.noarch
foreman-discovery-image-6.5-20140620.2.el6sat.noarch
ruby193-rubygem-foreman_openstack_simplify-0.0.6-8.el6ost.noarch
openstack-puppet-modules-2014.1-19.1.el6ost.noarch

Description:
The PXE file created for VMs with intention to boot from the HD (here: /var/lib/tftpboot/pxelinux.cfg/<MAC>) contains the following:

DEFAULT menu
PROMPT 0

MENU TITLE PXE Menu
TIMEOUT 200
TOTALTIMEOUT 6000
ONTIMEOUT local

LABEL local

MENU LABEL (local)
MENU DEFAULT
LOCALBOQOT 0

Result:
Some HW (for example Dell PowerEdge C6100) isn't able to boot the OS from the HD when this option is selected after booting via
PXE.

Expected result:
All machines should be able to boot from the HD, when selecting the "local”" option after booting via PXE.

Note: the following workaround found to be working on all machines (so far):
label local

MENU LABEL (local)

MENU DEFAULT

COM32 chain.c32

APPEND hd0 0
History

#1 - 07/22/2014 12:23 PM - Dominic Cleal

- Subject changed from Foreman: The "LOCALBOOT 0" entry causes some bare metal machines to stuck during boot. to The "LOCALBOQOT 0" entry
causes some bare metal machines to stuck during boot

- Category set to Templates

#2 - 08/15/2014 06:14 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Target version setto 1.7.5

- Pull request https://github.com/Katello/katello/pull/4585 added
- Pull request deleted ()

#3 - 08/15/2014 06:38 AM - Dominic Cleal

- Status changed from Ready For Testing to New

- Target version deleted (1.7.5)

- Pull request added

- Pull request deleted (https://github.com/Katello/katello/pull/4585)

#4 - 07/27/2016 01:48 PM - Simone Caldana

This happens also on virtual hosts with more than 1 NIC.
The workaround of adding

COM32 chain.c32
APPEND hdO 0

to the "PXELinux default local boot" template works

#5 - 07/28/2016 02:13 AM - Ohad Levy

Simone Caldana wrote:

This happens also on virtual hosts with more than 1 NIC.
The workaround of adding

(-]

to the "PXELinux default local boot" template works

this can be done conditionally in the template too, e.g. if you have more than one nic, or on specific hardware model. maybe you could consider
sending it as a patch to https:/github.com/theforeman/community-templates ?

thanks!

#6 - 02/15/2017 08:11 AM - Lukas Zapletal
Experiencing this on RHEV 4.0 (reported by Sat QA https://bugzilla.redhat.com/show_bug.cgi?id=1421656). Weird, what is causing this?

#7 - 04/07/2017 05:01 AM - Denis Muller
Ohad Levy wrote:

Simone Caldana wrote:

This happens also on virtual hosts with more than 1 NIC.
The workaround of adding

(-]

to the "PXELinux default local boot" template works

this can be done conditionally in the template too, e.g. if you have more than one nic, or on specific hardware model. maybe you could consider
sending it as a patch to https:/github.com/theforeman/community-templates ?

thanks!

Is it possible to select another Template for PXE local boot? Now we are using "Kickstart default PXELinux" as PXE Template, but there is no option
to select a another template for pxe local boot.
#8 - 04/07/2017 05:05 AM - Lukas Zapletal

Is it possible to select another Template for PXE local boot? Now we are using "Kickstart default PXELinux" as PXE Template, but there is no
option to select a another template for pxe local boot.

Unfortunately no, this is hardcoded in codebase: "#{kind} default local boot

Feel free to send a patch, this could be global variable or even host variable.

#9 - 04/20/2017 07:09 AM - Lukas Zapletal

For the record, | patched community-templates already, it's an alternative localboot option now. Not the default one tho.

#10 - 05/26/2017 04:37 AM - Lukas Zapletal

For the record, a change has been pushed into community-templates repository [1] which adds an entry called "Chainload the first hard drive (hd0)"
which uses chain.c32 method. Users can make it a default easily via "MENU DEFAULT" and "DEFAULT" options for all of their systems,
unfortunately there is no way of changing that per host as | believe @host variable is not available during template rendering (I haven't verified this,
template is currently locked due to issue #19677).

This change will be available in Foreman 1.15, users are able to easily do template edits in older versions tho. This is trivial operation.

#11 - 07/07/2017 09:33 AM - Frederic Schaer

Lukas Zapletal wrote:

(...) as | believe @host variable is not available during template rendering (I haven't verified this, template is currently locked due to issue #19677

).

Hi,

| faced the exact same issue, and another weird one too.
But to reply to previous comment, yes, the @host variable is available during template building, so | "fixed" this by editing the pxelinux_chainload
snippet with this :

(..0)

LABEL local
MENU LABEL Chainload into bootloader on the first disk
MENU DEFAULT

<% if @host.hostgroup.to_s.match(".*C6220.*") -%>
LOCALBOOT -1

<% else -%>
LOCALBOOT 0

<% end -%>

(..0)

Or put whatever you want in the if condition.

I WARNING !

Don't put a LOCALBOOT -1 on old dell R510s : | jut got bitten and faced PCle fatal errors on the network card after | reinstalled a host and after it

exited pxelinux after the install (I previously set localboot -1 for all hosts)

Cheers
